ColorToHex = {
    name            = "ColorToHex",
    author          = "Phuein",
    color           = "AA55EE",
    menuName        = "Color To Hex",
}

-- Default settings.
ColorToHex.savedVars = {
    firstLoad = true,
    accountWide = true,
    lastColor = 'ffffff',
}

-- Wraps text with a color.
function ColorToHex.Colorize(text, color)
    -- Default to addon's .color.
    if not color then color = ColorToHex.color end

    text = string.format('|c%s%s|r', color, text)

    return text
end

local function PrintHex(r, g, b)
    local selectedColor = ZO_ColorDef:New(r, g, b)

    ColorToHex.savedVars.lastColor = selectedColor:ToHex()

    CHAT_SYSTEM:StartTextEntry(selectedColor:ToHex())
	ZO_ChatWindowTextEntryEditBox:SelectAll()
end

function ColorToHex.ShowWindow()
    local color = ZO_ColorDef:New(ColorToHex.savedVars.lastColor)
    COLOR_PICKER:Show(PrintHex, color:UnpackRGB())
end

function ColorToHex.OnAddOnLoaded(event, addonName)
    if addonName ~= ColorToHex.name then return end
    EVENT_MANAGER:UnregisterForEvent(ColorToHex.name, EVENT_ADD_ON_LOADED)

    -- Load saved variables.
    ColorToHex.characterSavedVars = ZO_SavedVars:New("ColorToHexSavedVariables", 1, nil, ColorToHex.savedVars)
    ColorToHex.accountSavedVars = ZO_SavedVars:NewAccountWide("ColorToHexSavedVariables", 1, nil, ColorToHex.savedVars)

    if not ColorToHex.characterSavedVars.accountWide then
        ColorToHex.savedVars = ColorToHex.characterSavedVars
    else
        ColorToHex.savedVars = ColorToHex.accountSavedVars
    end

    -- Slash commands must be lowercase!!! Set to nil to disable.
    SLASH_COMMANDS["/c2h"] = ColorToHex.ShowWindow
end
EVENT_MANAGER:RegisterForEvent(ColorToHex.name, EVENT_ADD_ON_LOADED, ColorToHex.OnAddOnLoaded)